--[[
  Name: Recount FailBot Module
  Heavily based on: Ideas and code posted by sylvanaar
  Author: Elsia
]]

if not Recount then return end --  Forget about this if no Recount is present

local Recount = Recount

local RecountFailBot = LibStub("AceAddon-3.0"):NewAddon("RecountFailBot")
RecountFailBot.Version = tonumber(string.sub("$Revision: 3 $", 12, -3))

local RL = LibStub("AceLocale-3.0"):GetLocale("Recount")
local L = LibStub("AceLocale-3.0"):GetLocale("RecountFailBot")

local fail = LibStub("LibFail-1.0")
local fail_events = fail:GetSupportedEvents()

local DetailTitles={}
DetailTitles.FailedHow={
	TopNames = RL["Ability Name"],
	TopCount = "",
	TopAmount = RL["Count"],
	BotNames = "",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = RL["Count"]
}

local Epsilon=0.000000000000000001

function RecountFailBot:OnEnable()
end

function RecountFailBot:OnDisable()
end

-- Stolen straight from Sylvannars skeleton, don't use fatal but oh well
local function onFail(event, who, fatal)
	if not Recount.db2.combatants[who] then
		Recount:DPrint("No source combatant!")
	else
		local sourceData=Recount.db2.combatants[who]
		local sourceName = sourceData.Name
		Recount:AddAmount(sourceData,"Fails",1)
		Recount:AddTableDataStats(sourceData,"FailedHow",event,sourceName,1)
	end
end

for _, event in ipairs(fail_events) do
	fail:RegisterCallback(event, onFail)
end

function RecountFailBot:DataModesFailBot(data, num)
	if not data then return 0 end
	if num==1 then
		return (data.Fights[Recount.db.profile.CurDataSet].Fails or 0)
	else
		return (data.Fights[Recount.db.profile.CurDataSet].Fails or 0), {{data.Fights[Recount.db.profile.CurDataSet].FailedHow,L["'s Fail Events"],DetailTitles.FailedHow}}
	end
end

function RecountFailBot:TooltipFuncsFailBot(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData(RL["Top 3"].." "..L["Fails"],data and data.Fights[Recount.db.profile.CurDataSet] and data.Fights[Recount.db.profile.CurDataSet].FailedHow,3)
	GameTooltip:AddLine("<"..RL["Click for more Details"]..">",0,0.9,0)
end



Recount:AddModeTooltip(L["Fails"],RecountFailBot.DataModesFailBot,RecountFailBot.TooltipFuncsFailBot,nil,nil,nil,nil)
